 ###############################################################################
 #  Copyright 2008 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectColorFromImage < ActorEffect
	title				"Color from Image"
	description "Picks a color from a chosen X,Y position within a chosen image."

	setting 'image', :image
	setting 'x', :float, :range => -100.0..100.0, :default => 0.0..1.0
	setting 'y', :float, :range => -100.0..100.0, :default => 0.0..1.0
	setting 'alpha', :float, :range => 0.0..1.0, :default => 1.0..0.0

	def render
		color = image.color_at(x % 1.0, y % 1.0)
		a = color.to_a
		a[3] = alpha
		with_color(a) {
			yield
		}
	end
end
